/* arg_parser.c generated by valac 0.56.18, the Vala compiler
 * generated from arg_parser.vala, do not modify */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ARG_PARSER (arg_parser_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

/**
 * A lazy/minimal command-line arg parser because OptionContext segfaults.
 */
typedef enum  {
	ARG_PARSER_PARSE_ERROR
} ArgParser;
#define ARG_PARSER arg_parser_quark ()

VALA_EXTERN GQuark arg_parser_quark (void);
VALA_EXTERN GType arg_parser_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GeeMap* parse_args (gchar** args,
                    gint args_length1,
                    GError** error);
VALA_EXTERN gboolean isKey (const gchar* inval);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GQuark
arg_parser_quark (void)
{
	return g_quark_from_static_string ("arg-parser-quark");
}

static GType
arg_parser_get_type_once (void)
{
	static const GEnumValue values[] = {{ARG_PARSER_PARSE_ERROR, "ARG_PARSER_PARSE_ERROR", "parse-error"}, {0, NULL, NULL}};
	GType arg_parser_type_id;
	arg_parser_type_id = g_enum_register_static ("ArgParser", values);
	return arg_parser_type_id;
}

GType
arg_parser_get_type (void)
{
	static volatile gsize arg_parser_type_id__once = 0;
	if (g_once_init_enter (&arg_parser_type_id__once)) {
		GType arg_parser_type_id;
		arg_parser_type_id = arg_parser_get_type_once ();
		g_once_init_leave (&arg_parser_type_id__once, arg_parser_type_id);
	}
	return arg_parser_type_id__once;
}

/**
 * Convert ["-v", "-s", "asdf", "-f", "qwe"] => {("-v", null), ("-s", "adsf"), ("-f", "qwe")}
 * Populates key of "cmd" with first arg.
 * NOTE: Currently does not support quoted parameter values.
 */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 92 "arg_parser.c"
}

GeeMap*
parse_args (gchar** args,
            gint args_length1,
            GError** error)
{
	GeeHashMap* argMap = NULL;
	GeeHashMap* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gchar* lastKey = NULL;
	const gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
	GeeMap* result;
#line 16 "../src/arg_parser.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 16 "../src/arg_parser.vala"
	argMap = _tmp0_;
#line 18 "../src/arg_parser.vala"
	if (args == NULL) {
#line 18 "../src/arg_parser.vala"
		_tmp1_ = TRUE;
#line 115 "arg_parser.c"
	} else {
#line 18 "../src/arg_parser.vala"
		_tmp1_ = args_length1 == 0;
#line 119 "arg_parser.c"
	}
#line 18 "../src/arg_parser.vala"
	if (_tmp1_) {
#line 19 "../src/arg_parser.vala"
		result = (GeeMap*) argMap;
#line 19 "../src/arg_parser.vala"
		return result;
#line 127 "arg_parser.c"
	}
#line 22 "../src/arg_parser.vala"
	lastKey = NULL;
#line 131 "arg_parser.c"
	{
		gchar** token_collection = NULL;
		gint token_collection_length1 = 0;
		gint _token_collection_size_ = 0;
		gint token_it = 0;
#line 23 "../src/arg_parser.vala"
		token_collection = args;
#line 23 "../src/arg_parser.vala"
		token_collection_length1 = args_length1;
#line 23 "../src/arg_parser.vala"
		for (token_it = 0; token_it < token_collection_length1; token_it = token_it + 1) {
#line 143 "arg_parser.c"
			gchar* _tmp2_;
			gchar* token = NULL;
#line 23 "../src/arg_parser.vala"
			_tmp2_ = g_strdup (token_collection[token_it]);
#line 23 "../src/arg_parser.vala"
			token = _tmp2_;
#line 150 "arg_parser.c"
			{
				GeeHashMap* _tmp3_;
#line 24 "../src/arg_parser.vala"
				_tmp3_ = argMap;
#line 24 "../src/arg_parser.vala"
				if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, "cmd")) {
#line 157 "arg_parser.c"
					GeeHashMap* _tmp4_;
					const gchar* _tmp5_;
#line 25 "../src/arg_parser.vala"
					_tmp4_ = argMap;
#line 25 "../src/arg_parser.vala"
					_tmp5_ = token;
#line 25 "../src/arg_parser.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, "cmd", _tmp5_);
#line 166 "arg_parser.c"
				} else {
					const gchar* _tmp6_;
#line 26 "../src/arg_parser.vala"
					_tmp6_ = token;
#line 26 "../src/arg_parser.vala"
					if (isKey (_tmp6_)) {
#line 173 "arg_parser.c"
						const gchar* _tmp7_;
						const gchar* _tmp10_;
						gchar* _tmp11_;
#line 27 "../src/arg_parser.vala"
						_tmp7_ = lastKey;
#line 27 "../src/arg_parser.vala"
						if (_tmp7_ != NULL) {
#line 181 "arg_parser.c"
							GeeHashMap* _tmp8_;
							const gchar* _tmp9_;
#line 28 "../src/arg_parser.vala"
							_tmp8_ = argMap;
#line 28 "../src/arg_parser.vala"
							_tmp9_ = lastKey;
#line 28 "../src/arg_parser.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp8_, _tmp9_, NULL);
#line 190 "arg_parser.c"
						}
#line 30 "../src/arg_parser.vala"
						_tmp10_ = token;
#line 30 "../src/arg_parser.vala"
						_tmp11_ = g_strdup (_tmp10_);
#line 30 "../src/arg_parser.vala"
						_g_free0 (lastKey);
#line 30 "../src/arg_parser.vala"
						lastKey = _tmp11_;
#line 200 "arg_parser.c"
					} else {
						const gchar* _tmp12_;
#line 31 "../src/arg_parser.vala"
						_tmp12_ = lastKey;
#line 31 "../src/arg_parser.vala"
						if (_tmp12_ != NULL) {
#line 207 "arg_parser.c"
							GeeHashMap* _tmp13_;
							const gchar* _tmp14_;
							const gchar* _tmp15_;
#line 32 "../src/arg_parser.vala"
							_tmp13_ = argMap;
#line 32 "../src/arg_parser.vala"
							_tmp14_ = lastKey;
#line 32 "../src/arg_parser.vala"
							_tmp15_ = token;
#line 32 "../src/arg_parser.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, _tmp14_, _tmp15_);
#line 33 "../src/arg_parser.vala"
							_g_free0 (lastKey);
#line 33 "../src/arg_parser.vala"
							lastKey = NULL;
#line 223 "arg_parser.c"
						} else {
							const gchar* _tmp16_;
							const gchar* _tmp17_;
							gchar* _tmp18_;
							gchar* _tmp19_;
							GError* _tmp20_;
							GError* _tmp21_;
#line 35 "../src/arg_parser.vala"
							_tmp16_ = token;
#line 35 "../src/arg_parser.vala"
							_tmp17_ = string_to_string (_tmp16_);
#line 35 "../src/arg_parser.vala"
							_tmp18_ = g_strconcat ("Unexpected literal: ", _tmp17_, "\n", NULL);
#line 35 "../src/arg_parser.vala"
							_tmp19_ = _tmp18_;
#line 35 "../src/arg_parser.vala"
							_tmp20_ = g_error_new_literal (ARG_PARSER, ARG_PARSER_PARSE_ERROR, _tmp19_);
#line 35 "../src/arg_parser.vala"
							_tmp21_ = _tmp20_;
#line 35 "../src/arg_parser.vala"
							_g_free0 (_tmp19_);
#line 35 "../src/arg_parser.vala"
							_inner_error0_ = _tmp21_;
#line 35 "../src/arg_parser.vala"
							if (_inner_error0_->domain == ARG_PARSER) {
#line 35 "../src/arg_parser.vala"
								g_propagate_error (error, _inner_error0_);
#line 35 "../src/arg_parser.vala"
								_g_free0 (token);
#line 35 "../src/arg_parser.vala"
								_g_free0 (lastKey);
#line 35 "../src/arg_parser.vala"
								_g_object_unref0 (argMap);
#line 35 "../src/arg_parser.vala"
								return NULL;
#line 259 "arg_parser.c"
							} else {
#line 35 "../src/arg_parser.vala"
								_g_free0 (token);
#line 35 "../src/arg_parser.vala"
								_g_free0 (lastKey);
#line 35 "../src/arg_parser.vala"
								_g_object_unref0 (argMap);
#line 35 "../src/arg_parser.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 35 "../src/arg_parser.vala"
								g_clear_error (&_inner_error0_);
#line 35 "../src/arg_parser.vala"
								return NULL;
#line 273 "arg_parser.c"
							}
						}
					}
				}
#line 23 "../src/arg_parser.vala"
				_g_free0 (token);
#line 280 "arg_parser.c"
			}
		}
	}
#line 39 "../src/arg_parser.vala"
	_tmp22_ = lastKey;
#line 39 "../src/arg_parser.vala"
	if (_tmp22_ != NULL) {
#line 288 "arg_parser.c"
		GeeHashMap* _tmp23_;
		const gchar* _tmp24_;
#line 40 "../src/arg_parser.vala"
		_tmp23_ = argMap;
#line 40 "../src/arg_parser.vala"
		_tmp24_ = lastKey;
#line 40 "../src/arg_parser.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, _tmp24_, NULL);
#line 297 "arg_parser.c"
	}
#line 49 "../src/arg_parser.vala"
	result = (GeeMap*) argMap;
#line 49 "../src/arg_parser.vala"
	_g_free0 (lastKey);
#line 49 "../src/arg_parser.vala"
	return result;
#line 305 "arg_parser.c"
}

gboolean
isKey (const gchar* inval)
{
	gboolean result;
#line 52 "../src/arg_parser.vala"
	g_return_val_if_fail (inval != NULL, FALSE);
#line 53 "../src/arg_parser.vala"
	result = g_str_has_prefix (inval, "-");
#line 53 "../src/arg_parser.vala"
	return result;
#line 318 "arg_parser.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

